<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>Config.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">protean-tests</a> &gt; <a href="index.source.html" class="el_package">io.gitlab.littlesaints.protean.configuration</a> &gt; <span class="el_source">Config.java</span></div><h1>Config.java</h1><pre class="source lang-java linenums">/*
 *                     protean-core
 *              Copyright (C) 2018 Varun Anand
 *
 * This file is part of protean-core.
 *
 * protean-core is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * at your option) any later version.
 *
 * protean-core is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see &lt;http://www.gnu.org/licenses/&gt;.
 */

package io.gitlab.littlesaints.protean.configuration;

import java.util.Collections;
import java.util.HashMap;
import java.util.Map;

import lombok.ToString;

/**
 * @author Varun Anand
 * @since 1.0
 */
<span class="nc" id="L33">@ToString</span>
public class Config {

	private final Map&lt;String, Object&gt; values;

<span class="fc" id="L38">	public Config() {</span>
<span class="fc" id="L39">		this.values = new HashMap&lt;&gt;();</span>
<span class="fc" id="L40">	}</span>

<span class="fc" id="L42">	public Config(Map&lt;String, ?&gt; config) {</span>
<span class="fc" id="L43">		this.values = Collections.unmodifiableMap(config);</span>
<span class="fc" id="L44">	}</span>

	public Config(Config config) {
<span class="fc" id="L47">		this(config.values);</span>
<span class="fc" id="L48">	}</span>

	public &lt;T&gt; T get(String key) {
<span class="fc" id="L51">		return (T) values.get(key);</span>
	}

	public boolean contains(String key) {
<span class="nc" id="L55">		return values.containsKey(key);</span>
	}

	public Map&lt;String, Object&gt; getAll() {
<span class="nc" id="L59">		return values;</span>
	}

	public &lt;T&gt; T getOrDefault(String key, T defaultValue) {
<span class="fc" id="L63">		T value = get(key);</span>
<span class="pc bpc" id="L64" title="1 of 2 branches missed.">		if (null == value) {</span>
<span class="nc" id="L65">			value = defaultValue;</span>
		}
<span class="fc" id="L67">		return value;</span>
	}

	public static Config from(Map&lt;String, Object&gt; values) {
<span class="fc" id="L71">		return new Config(values);</span>
	}
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.4.201905082037</span></div></body></html>